;******************************************************************************
;* TITLE        : FILELIST.INC                                                *
;* Function     : This file contains a file table which provides the          *
;*                position of the file on the disc and its length             *
;*                                                                            *
;* Project #    : JAGUAR SLIDESHOW from Sample CD                             *
;* Programmer   : Pradip K Fatehpuria                                         *
;*                                                                            *
;* COPYRIGHT(c) 1992,1993 Atari Computer Corporation                          *
;* UNATHORIZED REPRODUCTION, ADAPTATION, DISTRIBUTION, PERFORMANCE OR         *
;* DISPLAY OF THIS COMPUTER PROGRAM OR THE ASSOCIATED AUDIOVISUAL WORK        *
;* IS STRICTLY PROHIBITED.  ALL RIGHTS RESERVED.                              *
;******************************************************************************

;******************************************************************************
;*      EQUATES                                                               *
;******************************************************************************

MAXFILES	equ	63

;******************************************************************************
;*      CONSTANT DATA AREA                                                    *
;******************************************************************************

	.data

;*============================================================================*
;*============================================================================*

filtable:	.phrase
		.dc.l	$00000200,$0004e070	;   1 BABY.CDR     - ($00000145) (  319600)
		.dc.l	$0000033d,$00001858	;   2 BALL.CDR     - ($00000337) (    6232)
		.dc.l	$00000340,$0001888c	;   3 BAT.CDR      - ($0000033a) (  100492)
		.dc.l	$00000420,$00003a64	;   4 BSKULL.CDR   - ($0000041a) (   14948)
		.dc.l	$00000427,$00012074	;   5 BUBBLB.CDR   - ($00000421) (   73844)
		.dc.l	$00000447,$00004874	;   6 BUBBLS.CDR   - ($00000441) (   18548)
		.dc.l	$00000504,$00007b6c	;   7 BUGGY.CDR    - ($00000449) (   31596)
		.dc.l	$00000512,$00012c74	;   8 BURPLB.CDR   - ($0000050c) (   76916)
		.dc.l	$00000533,$00004c74	;   9 BURPLS.CDR   - ($0000052d) (   19572)
		.dc.l	$0000053c,$00010064	;  10 CRYSTB.CDR   - ($00000536) (   65636)
		.dc.l	$0000060d,$0000f978	;  11 CUBE.CDR     - ($00000607) (   63864)
		.dc.l	$00000629,$00048064	;  12 DINO.CDR     - ($00000623) (  295012)
		.dc.l	$00000811,$00008064	;  13 DINOS.CDR    - ($0000080b) (   32868)
		.dc.l	$0000081f,$0000c860	;  14 DRAGON.CDR   - ($00000819) (   51296)
		.dc.l	$00000835,$0000605c	;  15 ELEC.CDR     - ($0000082f) (   24668)
		.dc.l	$00000840,$0000d064	;  16 EYELGBL.CDR  - ($0000083a) (   53348)
		.dc.l	$0000090c,$0000d064	;  17 EYELGGR.CDR  - ($00000906) (   53348)
		.dc.l	$00000923,$00007564	;  18 EYESMBL.CDR  - ($0000091d) (   30052)
		.dc.l	$00000930,$00007564	;  19 EYESMGR.CDR  - ($0000092a) (   30052)
		.dc.l	$0000093d,$00013e7c	;  20 FBUG.CDR     - ($00000937) (   81532)
		.dc.l	$00000a15,$00003864	;  21 FERN.CDR     - ($00000a0f) (   14436)
		.dc.l	$00000a1c,$00002060	;  22 FFLY.CDR     - ($00000a16) (    8288)
		.dc.l	$00000a20,$0001b484	;  23 FISHTX.CDR   - ($00000a1a) (  111748)
		.dc.l	$00000b05,$00000e64	;  24 FLOWER.CDR   - ($00000a4a) (    3684)
		.dc.l	$00000b07,$00011764	;  25 GEYSER.CDR   - ($00000b01) (   71524)
		.dc.l	$00000b26,$00007264	;  26 GLOWBUG.CDR  - ($00000b20) (   29284)
		.dc.l	$00000b33,$00002864	;  27 GUND.CDR     - ($00000b2d) (   10340)
		.dc.l	$00000b38,$00003668	;  28 HUMM.CDR     - ($00000b32) (   13928)
		.dc.l	$00000b3e,$00008d64	;  29 KILRUN.CDR   - ($00000b38) (   36196)
		.dc.l	$00000c03,$00005c74	;  30 MEDCRYSA.CDR - ($00000b48) (   23668)
		.dc.l	$00000c0e,$00005c74	;  31 MEDCRYSB.CDR - ($00000c08) (   23668)
		.dc.l	$00000c19,$00006058	;  32 MING.CDR     - ($00000c13) (   24664)
		.dc.l	$00000c24,$00014474	;  33 PEBBLB.CDR   - ($00000c1e) (   83060)
		.dc.l	$00000c48,$00008a74	;  34 PEBBLM.CDR   - ($00000c42) (   35444)
		.dc.l	$00000d0d,$00000658	;  35 POPPY1.CDR   - ($00000d07) (    1624)
		.dc.l	$00000d0e,$00001458	;  36 POPPY2.CDR   - ($00000d08) (    5208)
		.dc.l	$00000d11,$00016070	;  37 PROCKB.CDR   - ($00000d0b) (   90224)
		.dc.l	$00000d38,$00005a70	;  38 PROCKM.CDR   - ($00000d32) (   23152)
		.dc.l	$00000d42,$00001770	;  39 PROCKS.CDR   - ($00000d3c) (    6000)
		.dc.l	$00000d45,$0001847c	;  40 RAT.CDR      - ($00000d3f) (   99452)
		.dc.l	$00000e25,$00023060	;  41 ROBOT.CDR    - ($00000e1f) (  143456)
		.dc.l	$00000f17,$00011a74	;  42 ROCKB.CDR    - ($00000f11) (   72308)
		.dc.l	$00000f36,$00005c74	;  43 ROCKM.CDR    - ($00000f30) (   23668)
		.dc.l	$00000f41,$00001674	;  44 ROCKS.CDR    - ($00000f3b) (    5748)
		.dc.l	$00000f44,$0000ae68	;  45 SADMSK.CDR   - ($00000f3e) (   44648)
		.dc.l	$0000100c,$00037860	;  46 SCRPB.CDR    - ($00001006) (  227424)
		.dc.l	$00001122,$00004c5c	;  47 SCRPS.CDR    - ($0000111c) (   19548)
		.dc.l	$0000112b,$0000605c	;  48 SEYMEXP.CDR  - ($00001125) (   24668)
		.dc.l	$00001136,$00008a64	;  49 SEYMOUR.CDR  - ($00001130) (   35428)
		.dc.l	$00001146,$00002d60	;  50 SLUG.CDR     - ($00001140) (   11616)
		.dc.l	$00001200,$00002a5c	;  51 SNAKE0.CDR   - ($00001145) (   10844)
		.dc.l	$00001205,$00011d88	;  52 SPHERE.CDR   - ($0000114a) (   73096)
		.dc.l	$00001225,$00012060	;  53 SPIDBG.CDR   - ($0000121f) (   73824)
		.dc.l	$00001245,$00003364	;  54 SPINNER.CDR  - ($0000123f) (   13156)
		.dc.l	$00001300,$0000a864	;  55 SPORE.CDR    - ($00001245) (   43108)
		.dc.l	$00001313,$0000805c	;  56 STARB.CDR    - ($0000130d) (   32860)
		.dc.l	$00001321,$0000205c	;  57 STARM.CDR    - ($0000131b) (    8284)
		.dc.l	$00001325,$00005058	;  58 TOWER.CDR    - ($0000131f) (   20568)
		.dc.l	$0000132e,$0000ba74	;  59 TRI.CDR      - ($00001328) (   47732)
		.dc.l	$00001343,$0000045c	;  60 TRISHOT0.CDR - ($0000133d) (    1116)
		.dc.l	$00001344,$00000c5c	;  61 TRISHOT1.CDR - ($0000133e) (    3164)
		.dc.l	$00001346,$00000e5c	;  62 TRISHOT2.CDR - ($00001340) (    3676)
		.dc.l	$00001348,$00023494	;  63 VULT.CDR     - ($00001342) (  144532)
		.phrase

;******************************************************************************
;*      END OF FILE                                                           *
;******************************************************************************

	.end
