/******************************************************************************/
/* CD_MENU.C								      */
/******************************************************************************/

#include "st_def.h"
#include "st_struc.h"
#include "st_aes.h"
#include "st_bind.h"
#include "st_scrap.h"
#include "cd_bind.h"

/* -------------------------------------------------------------------------- */

extern	int	gl_scrhandle;

extern	GRECT	gl_scrbox;
extern	FDB	gl_nullfdb;

extern	CDROM	*gl_actdocu;

extern	GRECT	cd_inforect;
extern	GRECT	cd_datarect;

extern	long	cd_docuhite;

extern	long	cd_visy;

/* -------------------------------------------------------------------------- */

static	void	cd_vshift_scroll( long, long, GRECT * );
static	void	cd_insert_update( ITEM *, ITEM * );
static	void	cd_delete_update( ITEM *, ITEM * );

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

static	void	cd_vshift_scroll(fromy, toy, drawrect)
register long	fromy;
register long	toy;
register GRECT	*drawrect;
{
register long	visy;
register long	limy;
register int	yy;
GRECT	box;
int	copy[8];

	drawrect->g_x = cd_datarect.g_x;
	drawrect->g_w = cd_datarect.g_w;

	visy = cd_visy;
	if (fromy < visy)
	{
		visy += (toy - fromy);
		if (visy < 0L)
		{
			visy = 0L;
		}
		cd_visy = visy;

		drawrect->g_y = 0;
		drawrect->g_h = 0;
		return;
	}

	yy = cd_datarect.g_y + cd_datarect.g_h;
	limy = visy + (long)(cd_datarect.g_h - 1);

	if (fromy > limy)
	{
		if (toy > limy)
		{
			toy = (long)cd_datarect.g_h;
		}
		else
		{
			toy -= visy;
			if (toy < 0L)
			{
				cd_visy += toy;
				toy = 0L;
			}
		}

		drawrect->g_y = (int)toy + cd_datarect.g_y;
		drawrect->g_h = yy - drawrect->g_y;
		return;
	}

	fromy += (cd_datarect.g_y - cd_visy);
	if (toy > limy)
	{
		drawrect->g_y = (int)fromy;
		drawrect->g_h = yy - (int)fromy;
		return;
	}
	if (toy < visy)
	{
		cd_visy += (toy - visy);
	}
	toy += (cd_datarect.g_y - cd_visy);

	box.g_x = cd_datarect.g_x;
	box.g_y = cd_datarect.g_y;
	box.g_w = cd_datarect.g_w;
	box.g_h = cd_datarect.g_h;

	if (!rc_intersect(&gl_scrbox, &box))
	{
		drawrect->g_y = 0;
		drawrect->g_h = 0;
		return;
	}

	copy[0] = copy[4] = box.g_x;
	copy[2] = copy[6] = box.g_x + box.g_w - 1;

	copy[1] = (int)fromy;
	copy[5] = (int)toy;
	copy[3] = box.g_y + box.g_h - 1;
	copy[7] = copy[3] + copy[5] - copy[1];

	if (fromy != toy)
	{
		st_v_clip_boxon(&cd_datarect);
		st_mouse_hide();

		vro_cpyfm(gl_scrhandle, 3, copy, &gl_nullfdb, &gl_nullfdb);

		st_mouse_show();
		st_v_clip_boxoff(&cd_datarect);
	}
	if (copy[5] > copy[1])
	{
		drawrect->g_y = copy[1];
		drawrect->g_h = copy[5] - copy[1];
	}
	else
	{
		drawrect->g_y = copy[7] + 1;
		drawrect->g_h = copy[3] - copy[7];
	}
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

static	void	cd_insert_update(nextitem, itemlist)
register ITEM	*nextitem;
register ITEM	*itemlist;
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item;
register unsigned int	settings;
register unsigned int	save_settings;
register long	liny;
register int	offsety;
GRECT	box;

	if (!cd_saveundo())
	{
		for (item = itemlist ; item ; item = item->next)
		{
			free(item);
		}
		return;
	}

	cd_currsel(&cd_datarect);
	liny = cd_y_coordinate(nextitem) - nextitem->Hite;

	offsety = 0;
	for (item = itemlist ; item ; item = item->next)
	{
		offsety += item->Hite;
	}

	cd_vshift_scroll(liny, liny + offsety, &box);
	cd_docuhite += offsety;

	item = itemlist;
	if (item->prev = nextitem->prev)
		item->prev->next = item;
	else	docu->FirstItem = item;

	while (item->next != NULL) item = item->next;
	item->next = nextitem;
	nextitem->prev = item;

	save_settings = 0x0000;
	for (;;)
	{
		settings = item->Settings;
		save_settings |= settings;

		if (settings & IT_ITEM)		docu->NoItems ++;
		if (settings & IT_TRACK)	docu->NoTracks ++;
		if (settings & IT_SESSION)	docu->NoSessions ++;

		if (box.g_w && box.g_h)
		{
			cd_display_item(item, &box);
			cd_select_item(item, &box);
		}
		if (item == itemlist)
			break;
		item = item->prev;
	}
	docu->SelItem = itemlist;

	for (item = nextitem ; item ; item = item->next)
	{
		if ((save_settings & IT_SESSION) && (item->Settings & IT_SESSION))
		{
			cd_display_item(item, &cd_datarect);
			cd_select_item(item, &cd_datarect);
		}
		if ((save_settings & IT_TRACK) && (item->Settings & IT_TRACK))
		{
			cd_display_item(item, &cd_datarect);
			cd_select_item(item, &cd_datarect);
		}
	}
	cd_currsel(&cd_datarect);
	cd_setmenu_insert();
	cd_setmenu_empty();
	cd_set_vertslider();
	cd_display_info(&cd_inforect);
	cd_update_time(gl_actdocu);
	cd_update_disp();
	cd_visxy_update();
	st_set_savedocu();
	return;
}

/* -----------------------------------------------------------------------------
 */

static	void	cd_delete_update(nextitem, item)
register ITEM	*nextitem;
register ITEM	*item;
{
register CDROM	*docu = gl_actdocu;
register unsigned int	settings;
register long	liny;
GRECT	box;

	liny = cd_y_coordinate(nextitem) - nextitem->Hite;
	cd_vshift_scroll(liny, liny + item->Hite, &box);
	cd_docuhite += item->Hite;

	if (item->prev = nextitem->prev)
		item->prev->next = item;
	else	docu->FirstItem = item;
	item->next = nextitem;
	nextitem->prev = item;

	settings = item->Settings;
	if (settings & IT_ITEM)		docu->NoItems ++;
	if (settings & IT_TRACK)	docu->NoTracks ++;
	if (settings & IT_SESSION)	docu->NoSessions ++;
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_cut()
{
	st_clip_setpointer();
	cd_delete();
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_copy()
{
	st_clip_setpointer();
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_paste()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item;
register CDROM	*clipdocu;
register ITEM	*clipitem;
register ITEM	*newitem;
register unsigned int	cliptype;
register unsigned int	itemtype;

	if (!st_clip_gettype())
		return;

	clipdocu = st_clip_getpointer();
	item = docu->SelItem;

/* add track/item at the and of the clipboard, if necessary */

	clipitem = clipdocu->LastItem->prev;
	cliptype = clipitem->Settings;

	itemtype = item->Settings;

	if ((cliptype & IT_SESSION) && (itemtype & (IT_ITEM | IT_SESSION | IT_LAST)))
	{
		newitem = cd_create_item(IT_TRACK);
		if (newitem == NULL)
		{
			st_error_message(E_MALL);
			return;
		}
		newitem->next = clipitem->next;
		newitem->next->prev = newitem;
		newitem->prev = clipitem;
		clipitem->next = newitem;

		clipdocu->NoTracks ++;

		clipitem = newitem;
		cliptype = clipitem->Settings;
	}
	if ((cliptype & IT_TRACK) && (itemtype & (IT_TRACK | IT_SESSION | IT_LAST)))
	{
		newitem = cd_create_item(IT_ITEM);
		if (newitem == NULL)
		{
			st_error_message(E_MALL);
			return;
		}
		newitem->next = clipitem->next;
		newitem->next->prev = newitem;
		newitem->prev = clipitem;
		clipitem->next = newitem;

		clipdocu->NoItems ++;

		clipitem = newitem;
		cliptype = clipitem->Settings;
	}

/* add session/track/item at the begining of the clipboard, if necessary */

	clipitem = clipdocu->FirstItem;
	cliptype = clipitem->Settings;

	if ((item->prev == NULL) && (cliptype & (IT_ITEM | IT_TRACK)))
	{
		newitem = cd_create_item(IT_SESSION);
		if (newitem == NULL)
		{
			st_error_message(E_MALL);
			return;
		}
		newitem->next = clipitem;
		clipitem->prev = newitem;
		clipdocu->FirstItem = newitem;

		clipdocu->NoSessions ++;
	}

	itemtype = ((item->prev == NULL) ? 0x0000 : item->prev->Settings);

	if ((itemtype & IT_SESSION) && (cliptype & (IT_ITEM | IT_SESSION)))
	{
		newitem = cd_create_item(IT_TRACK);
		if (newitem == NULL)
		{
			st_error_message(E_MALL);
			return;
		}
		newitem->next = clipitem;
		clipitem->prev = newitem;
		clipdocu->FirstItem = newitem;

		clipdocu->NoTracks ++;
	}
	if ((itemtype & IT_TRACK) && (cliptype & (IT_TRACK | IT_SESSION)))
	{
		newitem = cd_create_item(IT_ITEM);
		if (newitem == NULL)
		{
			st_error_message(E_MALL);
			return;
		}
		newitem->next = clipitem;
		clipitem->prev = newitem;
		clipdocu->FirstItem = newitem;

		clipdocu->NoItems ++;
	}

/* now update the clipboard document so that the item list is in proper order */

	itemtype = (IT_ITEM | IT_TRACK | IT_SESSION);
	for (clipitem = clipdocu->FirstItem ; clipitem != clipdocu->LastItem ; clipitem = clipitem->next)
	{
		cliptype = clipitem->Settings;
		if (!(cliptype & itemtype))
		{
			cliptype = (itemtype & (IT_SESSION | IT_TRACK | IT_ITEM));

			newitem = cd_create_item(cliptype);
			if (newitem == NULL)
			{
				st_error_message(E_MALL);
				return;
			}
			if (newitem->prev = clipitem->prev)
				newitem->prev->next = newitem;
			else	clipdocu->FirstItem = newitem;
			newitem->next = clipitem;
			clipitem->prev = newitem;

			clipitem = newitem;
		}

		if (cliptype & IT_SESSION)	itemtype = IT_TRACK;
		if (cliptype & IT_TRACK)	itemtype = IT_ITEM;
		if (cliptype & IT_ITEM)		itemtype = IT_TYPE;
	}

/* now paste the clipboard at the proper position */

	clipitem = clipdocu->LastItem;
	clipitem->prev->next = NULL;

	cd_insert_update(gl_actdocu->SelItem, clipdocu->FirstItem);

	clipdocu->FirstItem = clipitem;
	st_clip_freeafterpaste();
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_delete()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item;
register ITEM	*next;
register ITEM	*newitem;
register long	liny;
register unsigned int	cur_type;
register unsigned int	req_type;
GRECT	box;

	if (docu->NoSelItems <= 0)
		return;

	if (!cd_saveundo())
		return;

	cd_currsel(&cd_datarect);

	for (item = docu->FirstItem ; item != docu->LastItem ; item = item->next)
	{
		if (!(item->Settings & IT_SELECTED))
			continue;

		liny = cd_y_coordinate(item);

		next = item->next;
		if (next->prev = item->prev)
			next->prev->next = next;
		else	docu->FirstItem = next;

		cd_vshift_scroll(liny, liny - item->Hite, &box);

		if (box.g_w && box.g_h)
		{
			cd_display(&box);
			cd_select(&box);
		}

		cd_docuhite -= item->Hite;

		if (item->Settings & IT_ITEM)		docu->NoItems --;
		if (item->Settings & IT_TRACK)		docu->NoTracks --;
		if (item->Settings & IT_SESSION)	docu->NoSessions --;

		if (docu->SelItem == item)		docu->SelItem = next;
		free(item);
	}

	req_type = (IT_SESSION | IT_LAST);
	for (item = docu->FirstItem ; item ; item = item->next)
	{
		cur_type = (item->Settings & IT_TYPE);

		if (!(req_type & cur_type))
		{
			cur_type = (req_type & (IT_SESSION | IT_TRACK | IT_ITEM));

			newitem = cd_create_item(cur_type);
			cd_delete_update(item, newitem);
			item = newitem;
		}

		if (cur_type & IT_SESSION)	req_type = IT_TRACK;
		if (cur_type & IT_TRACK)	req_type = IT_ITEM;
		if (cur_type & IT_ITEM)		req_type = IT_TYPE;

		if ((item == newitem) || (item->Settings & (IT_SESSION | IT_TRACK)))
		{
			cd_display_item(item, &cd_datarect);
		}
	}

	for (item = docu->FirstItem ; item != docu->LastItem ; item = item->next)
	{
		if (item->Settings & (IT_ITEM | IT_LAST))
			continue;

		cd_display_item(item, &cd_datarect);
	}

	docu->NoSelItems = 0;

	cd_currsel(&cd_datarect);
	cd_setmenu_insert();
	cd_setmenu_empty();
	cd_setmenu_select();
	cd_set_vertslider();
	cd_display_info(&cd_inforect);
	cd_update_time(gl_actdocu);
	cd_update_disp();
	cd_visxy_update();
	st_set_savedocu();
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_insert_session()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item = docu->SelItem;
register ITEM	*newsession;
register ITEM	*newtrack;
register ITEM	*newitem;

	if (docu->NoSessions >= MAX_SESSIONS)
	{
		return;
	}

	if (item->Settings & IT_ITEM)
	{
		return;
	}

	if (item->Settings & IT_TRACK)
	{
		if (item->prev->Settings & IT_SESSION)
			return;

		newsession = cd_create_item(IT_SESSION);
		if (newsession == NULL)
		{
			st_error_message(E_MALL);
			return;
		}
	}
	else
	{
		if ((docu->NoTracks >= MAX_TRACKS) || (docu->NoItems >= MAX_ITEMS))
			return;

		newsession = cd_create_item(IT_SESSION);
		newtrack = cd_create_item(IT_TRACK);
		newitem = cd_create_item(IT_ITEM);

		if ((newsession == NULL) || (newtrack == NULL) || (newitem == NULL))
		{
			if (newsession != NULL)	free(newsession);
			if (newtrack != NULL)	free(newtrack);
			if (newitem != NULL)	free(newitem);

			st_error_message(E_MALL);
			return;
		}

		newsession->next = newtrack;
		newtrack->prev = newsession;

		newtrack->next = newitem;
		newitem->prev = newtrack;
	}
	cd_insert_update(item, newsession);
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_insert_track()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item = docu->SelItem;
register ITEM	*newtrack;
register ITEM	*newitem;

	if (docu->NoTracks >= MAX_TRACKS)
	{
		return;
	}

	if (item->Settings & IT_ITEM)
	{
		if (item->prev->Settings & IT_TRACK)
			return;

		newtrack = cd_create_item(IT_TRACK);
		if (newtrack == NULL)
		{
			st_error_message(E_MALL);
			return;
		}
	}
	else
	{
		if (docu->NoItems >= MAX_ITEMS)
		{
			return;
		}

		if (item->Settings & (IT_SESSION | IT_LAST))
		{
			if (item == docu->FirstItem)
				return;
		}

		newtrack = cd_create_item(IT_TRACK);
		newitem = cd_create_item(IT_ITEM);

		if ((newtrack == NULL) || (newitem == NULL))
		{
			if (newtrack != NULL)	free(newtrack);
			if (newitem != NULL)	free(newitem);

			st_error_message(E_MALL);
			return;
		}

		newtrack->next = newitem;
		newitem->prev = newtrack;
	}
	cd_insert_update(item, newtrack);
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_insert_file()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item = docu->SelItem;
register ITEM	*newitem;

	if (docu->NoItems >= MAX_ITEMS)
		return;

	if (item->Settings & IT_TRACK)
	{
		if (item->prev->Settings & IT_SESSION)
			return;
	}
	else
	if (item->Settings & (IT_SESSION | IT_LAST))
	{
		if (item == docu->FirstItem)
			return;
	}

	newitem = cd_create_item(IT_ITEM);
	if (newitem == NULL)
	{
		st_error_message(E_MALL);
		return;
	}
	cd_insert_update(item, newitem);
	return;
}

/******************************************************************************/
/* End of CD_MENU.C							      */
/******************************************************************************/

