/******************************************************************************/
/* CD_SCROL.C								      */
/******************************************************************************/

#include "st_def.h"
#include "st_struc.h"
#include "st_aes.h"
#include "cd_bind.h"

/* -------------------------------------------------------------------------- */

extern	CDROM	*gl_actdocu;

extern	GRECT	cd_titlrect;
extern	GRECT	cd_inforect;
extern	GRECT	cd_headrect;
extern	GRECT	cd_datarect;

extern	int	cd_commstartx;

extern	long	cd_docuhite;

extern	long	cd_visx;
extern	long	cd_visy;

extern	ITEM	*cd_inv_item;

/* -------------------------------------------------------------------------- */

static	void	cd_alt_button( void );

static	void	cd_item_button( long );
static	void	cd_item_next( ITEM *, ITEM * );
static	void	cd_item_prev( ITEM *, ITEM * );

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_key_pageup()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item;

	cd_wind_arrowed(0);
	cd_inv_coordinate(cd_visy);
	item = cd_inv_item;

	cd_currsel(&cd_datarect);
	docu->SelItem = item;
	cd_currsel(&cd_datarect);
	cd_scroll_disp();
	cd_setmenu_insert();
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_key_pagedown()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item;

	cd_wind_arrowed(1);
	cd_inv_coordinate(cd_visy + (long)(cd_datarect.g_h - 1));
	item = cd_inv_item;

	cd_currsel(&cd_datarect);
	docu->SelItem = item;
	cd_currsel(&cd_datarect);
	cd_scroll_disp();
	cd_setmenu_insert();
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_key_home()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item = docu->FirstItem;

	cd_currsel(&cd_datarect);
	docu->SelItem = item;
	cd_currsel(&cd_datarect);
	cd_scroll_disp();
	cd_setmenu_insert();
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_key_end()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item = docu->LastItem;

	cd_currsel(&cd_datarect);
	docu->SelItem = item;
	cd_currsel(&cd_datarect);
	cd_scroll_disp();
	cd_setmenu_insert();
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_key_up()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item = docu->SelItem;

	if (item == docu->FirstItem)
	{
		cd_scroll_disp();
		return;
	}
	item = item->prev;

	cd_currsel(&cd_datarect);
	docu->SelItem = item;
	cd_currsel(&cd_datarect);
	cd_scroll_disp();
	cd_setmenu_insert();
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_key_down()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item = docu->SelItem;

	if (item == docu->LastItem)
	{
		cd_scroll_disp();
		return;
	}
	item = item->next;

	cd_currsel(&cd_datarect);
	docu->SelItem = item;
	cd_currsel(&cd_datarect);
	cd_scroll_disp();
	cd_setmenu_insert();
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_key_select()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item = docu->SelItem;

	if (item == docu->LastItem)
		return;

	cd_currsel(&cd_datarect);
	if (item->Settings & IT_SELECTED)
	{
		cd_select_item(item, &cd_datarect);
		item->Settings &= ~IT_SELECTED;
		docu->NoSelItems --;
	}
	else
	{
		item->Settings |= IT_SELECTED;
		cd_select_item(item, &cd_datarect);
		docu->NoSelItems ++;
	}
	cd_currsel(&cd_datarect);
	cd_scroll_disp();
	cd_setmenu_select();
	return;
}

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 * This routine takes care of the button event occuring inside the window
 * and accordingly takes the action
 *
 * Input parameters :
 *	mx, my : point where the mouse button is clicked
 *	kstate : key states when button is clicked
 *	times  : number of times button is clicked
 */

void	cd_handle_button(mx, my, kstate, times)
int	mx, my;
int	kstate;
int	times;
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item;
register long	linx;
register long	liny;

	if ((mx > cd_titlrect.g_x) && (mx < (cd_titlrect.g_x + cd_titlrect.g_w)) &&
	    (my > cd_titlrect.g_y) && (my < (cd_titlrect.g_y + cd_titlrect.g_h)))
	{
		if (times == 2)
		{
			cd_dial_cdromtitle();
		}
		st_evnt_waitforbuttonup();
		return;
	}

	if ((mx > cd_inforect.g_x) && (mx < (cd_inforect.g_x + cd_inforect.g_w)) &&
	    (my > cd_inforect.g_y) && (my < (cd_inforect.g_y + cd_inforect.g_h)))
	{
		cd_deselect();
		cd_setmenu_select();
		st_evnt_waitforbuttonup();
		return;
	}

	if ((mx > cd_headrect.g_x) && (mx < (cd_headrect.g_x + cd_headrect.g_w)) &&
	    (my > cd_headrect.g_y) && (my < (cd_headrect.g_y + cd_headrect.g_h)))
	{
		cd_deselect();
		cd_setmenu_select();
		st_evnt_waitforbuttonup();
		return;
	}

	if ((mx < cd_datarect.g_x) || (mx >= (cd_datarect.g_x + cd_datarect.g_w)) ||
	    (my < cd_datarect.g_y) || (my >= (cd_datarect.g_y + cd_datarect.g_h)))
	{
		st_evnt_waitforbuttonup();
		return;
	}

	liny = cd_inv_coordinate((long)(my - cd_datarect.g_y) + cd_visy);
	item = cd_inv_item;
	if (item == NULL)
	{
		st_evnt_waitforbuttonup();
		return;
	}

	if (item->Settings & IT_LAST)
	{
		cd_currsel(&cd_datarect);
		docu->SelItem = item;
		cd_currsel(&cd_datarect);
		cd_setmenu_insert();
		st_evnt_waitforbuttonup();
		return;
	}

	if (times == 2)
	{
		cd_currsel(&cd_datarect);
		if (!(item->Settings & IT_SELECTED))
		{
			item->Settings |= IT_SELECTED;
			cd_select_item(item, &cd_datarect);
			docu->NoSelItems ++;
			cd_setmenu_select();
		}
		docu->SelItem = item;
		cd_currsel(&cd_datarect);
		cd_setmenu_insert();

		linx = (long)(mx - cd_datarect.g_x) + cd_visx;
		if (linx <= (long)cd_commstartx)
		{
			if (item->Settings & IT_ITEM)
				cd_edit_filename();
		}
		else
		{
			cd_add_comments();
		}
		st_evnt_waitforbuttonup();
		return;
	}

	if (kstate & 0x0008)
		cd_alt_button();
	else	cd_item_button(liny);

	st_evnt_waitforbuttonup();
	return;
}

/* -----------------------------------------------------------------------------
 */

static	void	cd_alt_button()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item = cd_inv_item;

	cd_deselect();
	cd_currsel(&cd_datarect);
	if (!(item->Settings & IT_SELECTED))
	{
		item->Settings |= IT_SELECTED;
		cd_select_item(item, &cd_datarect);
		docu->NoSelItems ++;
	}
	docu->SelItem = item;
	cd_currsel(&cd_datarect);

	if (item->Settings & IT_SESSION)
	{
		item = item->next;
		while (!(item->Settings & (IT_SESSION | IT_LAST)))
		{
			if (!(item->Settings & IT_SELECTED))
			{
				item->Settings |= IT_SELECTED;
				cd_select_item(item, &cd_datarect);
				docu->NoSelItems ++;
			}
			item = item->next;
		}
	}
	else
	if (item->Settings & IT_TRACK)
	{
		item = item->next;
		while (!(item->Settings & (IT_SESSION | IT_TRACK | IT_LAST)))
		{
			if (!(item->Settings & IT_SELECTED))
			{
				item->Settings |= IT_SELECTED;
				cd_select_item(item, &cd_datarect);
				docu->NoSelItems ++;
			}
			item = item->next;
		}
	}
	cd_setmenu_insert();
	cd_setmenu_select();
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

static	void	cd_item_button(liny)
register long	liny;
{
register CDROM	*docu = gl_actdocu;

register ITEM	*sav_item = cd_inv_item;
register long	sav_liny = liny;

register ITEM	*cur_item = cd_inv_item;
register long	cur_liny = liny;

register long	lin_miny, lin_maxy;
register int	win_miny, win_maxy;

register long	newy;

int	my, bstate, junk;

	cd_currsel(&cd_datarect);
	if (cur_item->Settings & IT_SELECTED)
	{
		cd_select_item(cur_item, &cd_datarect);
		cur_item->Settings &= ~IT_SELECTED;
		docu->NoSelItems --;
	}
	else
	{
		cur_item->Settings |= IT_SELECTED;
		cd_select_item(cur_item, &cd_datarect);
		docu->NoSelItems ++;
	}
	docu->SelItem = cur_item;
	cd_currsel(&cd_datarect);

	lin_miny = 0;
	lin_maxy = cd_y_coordinate(docu->LastItem->prev);

	win_miny = cd_datarect.g_y;
	win_maxy = cd_datarect.g_y + cd_datarect.g_h - 1;

	for (;;)
	{
		graf_mkstate(&junk, &my, &bstate, &junk);
		if (!(bstate & 0x0001))
			break;

		if (my < win_miny)
		{
			if (lin_miny <= cd_visy)
			{
				cd_wind_arrowed(2);
			}
			my = win_miny;
		}
		else
		if (my > win_maxy)
		{
			if (lin_maxy > (cd_visy + (long)(cd_datarect.g_h - 1)))
			{
				cd_wind_arrowed(3);
			}
			my = win_maxy;
		}
		newy = cd_visy + (long)(my - cd_datarect.g_y);
		if (newy < lin_miny)	newy = lin_miny;
		if (newy > lin_maxy)	newy = lin_maxy;

		liny = cd_inv_coordinate(newy);
		if (liny == cur_liny)
			continue;

		if (cur_liny > sav_liny)
		{
			if (liny > cur_liny)
			{
				cd_item_next(cur_item->next, cd_inv_item);
			}
			else
			if (liny < sav_liny)
			{
				cd_item_prev(cur_item, sav_item->next);
				cd_item_prev(sav_item->prev, cd_inv_item);
			}
			else
			{
				cd_item_prev(cur_item, cd_inv_item->next);
			}
		}
		else
		if (cur_liny < sav_liny)
		{
			if (liny < cur_liny)
			{
				cd_item_prev(cur_item->prev, cd_inv_item);
			}
			else
			if (liny > sav_liny)
			{
				cd_item_next(cur_item, sav_item->prev);
				cd_item_next(sav_item->next, cd_inv_item);
			}
			else
			{
				cd_item_next(cur_item, cd_inv_item->prev);
			}
		}
		else
		{
			if (liny < cur_liny)
			{
				cd_item_prev(cur_item->prev, cd_inv_item);
			}
			else
			{
				cd_item_next(cur_item->next, cd_inv_item);
			}
		}
		cur_item = cd_inv_item;
		cur_liny = liny;
	}
	cd_setmenu_insert();
	cd_setmenu_select();
	return;
}

/* -----------------------------------------------------------------------------
 */

static	void	cd_item_next(from_item, to_item)
register ITEM	*from_item;
register ITEM	*to_item;
{
register ITEM	*item = from_item;

	while (item != NULL)
	{
		if (item->Settings & IT_SELECTED)
		{
			cd_select_item(item, &cd_datarect);
			item->Settings &= ~IT_SELECTED;
			gl_actdocu->NoSelItems --;
		}
		else
		{
			item->Settings |= IT_SELECTED;
			cd_select_item(item, &cd_datarect);
			gl_actdocu->NoSelItems ++;
		}
		if (item == to_item)
			break;

		item = item->next;
	}
	return;
}

/* -----------------------------------------------------------------------------
 */

static	void	cd_item_prev(from_item, to_item)
register ITEM	*from_item;
register ITEM	*to_item;
{
register ITEM	*item = from_item;

	while (item != NULL)
	{
		if (item->Settings & IT_SELECTED)
		{
			cd_select_item(item, &cd_datarect);
			item->Settings &= ~IT_SELECTED;
			gl_actdocu->NoSelItems --;
		}
		else
		{
			item->Settings |= IT_SELECTED;
			cd_select_item(item, &cd_datarect);
			gl_actdocu->NoSelItems ++;
		}
		if (item == to_item)
			break;

		item = item->prev;
	}
	return;
}

/******************************************************************************/
/* End of CD_SCROL.C							      */
/******************************************************************************/
