/******************************************************************************/
/* ST_KEY.C								      */
/******************************************************************************/

#include "st_def.h"
#include "st_key.h"

/* -------------------------------------------------------------------------- */

unsigned int	gl_key_status;

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

int	st_key_check()
{
register long	happened;
unsigned int	key;
int	junk;

	happened = evnt_multi((MU_KEYBD | MU_TIMER),
				0, 0, 0, 
				0, 0,0,0,0, 0, 0,0,0,0, 
				&junk, 5, 0, 
				&junk, &junk, &junk, &junk, &key, &junk);

	if (happened & MU_KEYBD)
	{
		key = st_key_process(key);
		if (key == CTRL_C)
		{
			return(FALSE);
		}
	}
	return(TRUE);
}

/* -----------------------------------------------------------------------------
 */

#define	NO_ARBIT_KEYS	14

unsigned int	st_key_process(key)
register unsigned int	key;
{

static	unsigned int	ArbitKeys[] =
	{
	0x4B34, /* Shift Left Arrow */
	0x4D36, /* Shift Right Arrow */
	0x4838, /* Shift Up Arrow */
	0x5032, /* Shift Down Arrow */
	0x5230, /* Shift Insert */
	0x4737, /* Shift Home */
	0x011B, /* Escape */
	0x0E08, /* BackSpace */
	0x537F, /* Delete */
	0x531F, /* Control Delete */
	0x1C0D, /* CR */
	0x1C0A, /* Control CR */
	0x720D, /* Enter (keypad) */
	0x0F09  /* Tab */
	};

register unsigned int	ascii_val;
register unsigned int	key_status;
register int	i;

/* If valid ascii value than check is the keys are actually other */
/* than what the ascii value represents */

	if (ascii_val = (key & 0x00FF))
	{
		i = 0;
		while ((i < NO_ARBIT_KEYS) && (key != ArbitKeys[i]))
		{
			i++;
		}

/* If the key has a proper ASCII value and it is not one of the above */
/* keys which also generate some ASCII value then return */

		if (i < NO_ARBIT_KEYS)
		{
			key_status = Getshift(-1);
			key_status &= ~StSTAT_CAPS;
			gl_key_status = key_status;

			if ((key == KEY_TAB) && ((key_status == StSTAT_LSHIFT) || (key_status == StSTAT_RSHIFT)))
			{
				key = SHFT_TAB;
			}

			if (key == CTRL_DEL)
			{
				key = KEY_DEL;
				gl_key_status |= StSTAT_CTRL;
			}

/* Return the control key */

			return(key);
		}

/* If proper ascii value (i.e. anything above the space character) */
/* then return the key as a proper printable works character */

		if (ascii_val >= 0x20)
		{
			return(ascii_val);
		}
	}

/* Control keys with CTRL and any other key defined by atari */
/* key board are transleted like this here */

	if ((key & 0xFF00) && ascii_val)
	{
		key_status = Getshift(-1);
		key_status &= ~(StSTAT_CAPS | StSTAT_CTRL);
		gl_key_status = key_status;

		if ((key_status == StSTAT_LSHIFT) || (key_status == StSTAT_RSHIFT))
		{
			key = (ascii_val | 0xD000);
		}
		else
		{
			key = (ascii_val | 0xC000);
		}
		return(key);
	}

/* if ascii code entered from the numeric keypad and its */
/* less than 0x20 ASCII then not a valid key */

	if (key < 0x20)
	{
		return(key | 0xFF00);
	}
	return(key);
}

#undef	NO_ARBIT_KEYS

/******************************************************************************/
/* End of ST_KEY.C							      */
/******************************************************************************/
