/******************************************************************************/
/* ST_LIB.C								      */
/******************************************************************************/

#include "st_def.h"
#include "st_struc.h"
#include "st_aes.h"
#include "st_bind.h"
#include "st_lib.h"

/* -------------------------------------------------------------------------- */

extern	int	gl_scrhandle;
extern	GRECT	gl_scrbox;
extern	FDB	gl_nullfdb;

extern	unsigned int	gl_tos_version;

extern	unsigned char	gl_pathname[];

/* -------------------------------------------------------------------------- */

static	int	st_scroll_disp( int, GRECT * );

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

static	int	st_scroll_disp(handle, area)
register int	handle;
register GRECT	*area;
{
GRECT	a, b;

	wind_get(handle, WF_FIRSTXYWH, &a.g_x, &a.g_y, &a.g_w, &a.g_h);
	for (;;)
	{
		wind_get(handle, WF_NEXTXYWH, &b.g_x, &b.g_y, &b.g_w, &b.g_h);
		if (!b.g_w || !b.g_h)
			break;

		b.g_x = area->g_x;
		b.g_y = area->g_y;
		b.g_w = area->g_w;
		b.g_h = area->g_h;
		st_display_window(handle, b);

		while (b.g_w && b.g_h)
		{
			wind_get(handle, WF_NEXTXYWH, &b.g_x, &b.g_y, &b.g_w, &b.g_h);
		}

		area->g_w = 0;
		area->g_h = 0;

		return(TRUE);
	}

	rc_intersect(&a, area);
	return(FALSE);
}

/* -----------------------------------------------------------------------------
 */

void	st_scroll_v(handle, area, shift)
register int	handle;
register GRECT	*area;
register long	shift;
{
int	copy[8];

	if (st_scroll_disp(handle, area))
		return;

	if (!rc_intersect(&gl_scrbox, area))
		return;

	if ((shift >= (long)area->g_h) || (-shift >= (long)area->g_h))
		return;

	copy[0] = copy[4] = area->g_x;
	copy[2] = copy[6] = area->g_x + area->g_w - 1;
	copy[1] = copy[5] = area->g_y;
	copy[3] = copy[7] = area->g_y + area->g_h - 1;

	copy[5] += (int)shift;
	copy[7] += (int)shift;

	st_v_clip_boxon(area);
	st_mouse_hide();

	vro_cpyfm(gl_scrhandle, 3, copy, &gl_nullfdb, &gl_nullfdb);

	st_mouse_show();
	st_v_clip_boxoff(area);

	if (shift < 0l)
	{
		area->g_y += (area->g_h + (int)shift);
	}
	area->g_h = abs((int)shift);
	return;
}

/* -----------------------------------------------------------------------------
 */

void	st_scroll_h(handle, area, shift)
register int	handle;
register GRECT	*area;
register long	shift;
{
int	copy[8];

	if (st_scroll_disp(handle, area))
		return;

	if (!rc_intersect(&gl_scrbox, area))
		return;

	if ((shift >= (long)area->g_w) || (-shift >= (long)area->g_w))
		return;

	copy[1] = copy[5] = area->g_y;
	copy[3] = copy[7] = area->g_y + area->g_h - 1;
	copy[0] = copy[4] = area->g_x;
	copy[2] = copy[6] = area->g_x + area->g_w - 1;

	copy[4] += (int)shift;
	copy[6] += (int)shift;

	st_v_clip_boxon(area);
	st_mouse_hide();

	vro_cpyfm(gl_scrhandle, 3, copy, &gl_nullfdb, &gl_nullfdb);

	st_mouse_show();
	st_v_clip_boxoff(area);

	if (shift < 0l)
	{
		area->g_x += (area->g_w + (int)shift);
	}
	area->g_w = abs((int)shift);
	return;
}

/******************************************************************************/
/******************************************************************************/

static	unsigned char	stTOC_Filename[ MAX_PATHNAME ];

/* -----------------------------------------------------------------------------
 */

void	st_init_pathnames()
{
	strcpy(stTOC_Filename, gl_pathname);
	st_set_curpath(gl_pathname);
	return;
}

/* -----------------------------------------------------------------------------
 */

int	st_save_pathnames(fp)
FILE	*fp;
{
unsigned char	header[10];
unsigned char	pathname[ MAX_PATHNAME ];

	st_get_curpath(pathname);

	header[0] = (unsigned char)strlen(pathname);
	header[1] = (unsigned char)strlen(stTOC_Filename);

	if (!fwrite(header, (size_t)1, (size_t)2, fp))
		return(FALSE);

	if ((header[0] && !fwrite(pathname      , (size_t)1, (size_t)header[0], fp)) ||
	    (header[1] && !fwrite(stTOC_Filename, (size_t)1, (size_t)header[1], fp)))
		return(FALSE);

	return(TRUE);
}

/* -----------------------------------------------------------------------------
 */

int	st_load_pathnames(fp)
FILE	*fp;
{
unsigned char	header[10];
unsigned char	old_pathname[ MAX_PATHNAME ];
unsigned char	pathname[ MAX_PATHNAME ];

	if (!fread(header, (size_t)1, (size_t)2, fp))
		return(FALSE);

	if ((header[0] >= MAX_PATHNAME) ||
	    (header[1] >= MAX_PATHNAME))
		return(FALSE);

	if ((header[0] && !fread(pathname      , (size_t)1, (size_t)header[0], fp)) ||
	    (header[1] && !fread(stTOC_Filename, (size_t)1, (size_t)header[1], fp)))
		return(FALSE);

	pathname[ header[0] ] = '\0';
	stTOC_Filename[ header[1] ] = '\0';

	st_get_curpath(old_pathname);
	if (!st_set_curpath(pathname))
	{
		st_set_curpath(old_pathname);
	}
	return(TRUE);
}

/* -----------------------------------------------------------------------------
 */

unsigned char	*st_ret_TOCpathname()	{ return(stTOC_Filename); }

/* -----------------------------------------------------------------------------
 */

int	st_get_TOCfilename(mode, filename)
register int	mode;
register unsigned char	filename[];
{
register int	item;

	item = ((mode == AREAD) ? FSEL_LOAD_TOC : FSEL_SAVE_TOC);
	strcpy(filename, stTOC_Filename);

	if (!st_get_filename(1, mode, filename, ".TOC", item))
		return(FALSE);

	strcpy(stTOC_Filename, filename);
	return(TRUE);
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 * Get a file name using File Selector box. The path name to be used is the
 * current ST Sutra directory.  The file to be opened is in the given mode.
 * The type of files are given by "Which" and "append".
 *
 * "which == 1" means force append the given extension and
 * "which == 0" means not.
 */

int	st_get_filename(which, mode, filename, append, item)
register int	which;
register int	mode;
register unsigned char	filename[];
register unsigned char	append[];
int	item;
{
register unsigned char	*cp;
register int	pathflag;
register int	ret;
unsigned char	name[16];
unsigned char	*fsel_str;
int	button;

/* the string to be displayed in the file selector box */

	fsel_str = st_freestr(item);

/* if the 'filaname' contains a complete pathname then use this */
/* pathname otherwise get the default pathname from the system */

	if (cp = strrchr(filename, '\\'))
	{
		cp ++;
		strcpy(name, cp);
		(*cp) = '\0';
		pathflag = FALSE;
	}
	else
	{
		strcpy(name, filename);
		st_get_curpath(filename);
		pathflag = TRUE;
	}
	strcat(filename, "*");
	strcat(filename, append);

/* call the file selector box routine */

	st_mouse_free();
	ret = ((gl_tos_version < 0x0104) ?
			fsel_input(filename, name, &button) :
			fsel_exinput(filename, name, &button, fsel_str));
	if (!ret)
	{
		st_error_message(E_FSI);
		return(FALSE);
	}

	if (!button)
		return(FALSE);

/* if no file or pathname is selected then show an error message */

	if (!filename[0] || !name[0])
	{
		st_error_message(E_INVALIDFNAME);
		return(FALSE);
	}

/* convert pathname and the file name in upper case letters */

	st_str_toupper(filename);
	st_str_toupper(name);

/* build the pathname by removing the wild card at the end */

	if (!(cp = strrchr(filename, '\\')))
	{
		st_error_message(E_INVALIDFNAME);
		return(FALSE);
	}
	cp[1] = '\0';

/* set the default pathname if required */

	if (pathflag && !st_set_curpath(filename))
	{
		st_error_message(E_INVALIDFNAME);
		return(FALSE);
	}

/* if invalid characters in name then return */

	if (strchr(name, '*') ||  strchr(name, '?'))
	{
		st_error_message(E_INVALIDFNAME);
		return(FALSE);
	}

/* if which is '1', set the file extention to current document type */

	if ((which == 1) && strcmp(append, ".*"))
	{
		if (cp = strrchr(name, '.'))
			(*cp) = '\0';
		strcat(name, append);
	}

/* if which is '2', set the extension to the requested one only */
/* if the user does not specify any other extension */

	if ((which == 2) && strcmp(append, ".*"))
	{
		if ((cp = strrchr(name, '.')) && !cp[1])
		{
			(*cp) = '\0';
			cp = NULL;
		}
		if (!cp)
			strcat(name, append);
	}

/* prepare the selected file name with full path */

	strcat(filename, name);

/* if no mode requested then return the selected pathname */

	if (mode < 0)
		return(TRUE);

/* check for accessing the file in the given mode */
/* assuming that if requested mode is WRITE and accessing the */
/* file in READ mode if not succesful, then the file does not exist */

	if (access(filename, AREAD))
	{

/* access failure in READ mode. */

		if (mode == AREAD)
		{
			st_error_message(E_ACCESSF);
			return(FALSE);
		}

/* else the 'mode' must be WRITE and if this is not accessible */
/* in READ mode, then this means the file does not exist. So */
/* it can be opened in WRITE mode */

		return(TRUE);
	}

/* if requested mode is READ then return with TRUE value */

	if (mode == AREAD)
		return(TRUE);

/* file exist then check for, requested WRITE mode */

	if (access(filename, AWRITE))
	{
		st_error_message(E_ACCESSF);
		return(FALSE);
	}

/* file exists and accessible in WRITE, so check for OVERWRITE */

	return((st_error_message(E_FILEXIST) == 2) ? FALSE : TRUE);
}

/******************************************************************************/
/* End of ST_LIB.C							      */
/******************************************************************************/

