/******************************************************************************/
/* ST_STRUC.H								      */
/******************************************************************************/

#ifndef	__HEADER_ST_STRUC
#define	__HEADER_ST_STRUC	__HEADER_ST_STRUC

/* -------------------------------------------------------------------------- */
/*
 * This file contains the data structures required for CD ROM Emulator
 * The structure is global to all procedures that access it.
 */
/* -------------------------------------------------------------------------- */

/******************************************************************************/
/******************************************************************************/

/* -------------------------------------------------------------------------- */

#define	MAX_FRMSIZE	2352	/* number of bytes in a frame */
#define	MAX_SECSIZE	75	/* number of frames in a second */
#define	MAX_MINSIZE	4500	/* number of frames in a minute */

#define	MAX_SESSIONS	99
#define	MAX_TRACKS	99
#define	MAX_ITEMS	32000

#define	MAX_COMLEN	66
#define	MAX_ROMNAME	32

#define	MAX_SRCHSTRS	32

#define	MAX_ERRORLEN	80

#define	MAX_LINELEN	80

/* -------------------------------------------------------------------------- */

#define	PRELOAD_BUFFSIZE	0xC00000l	/* a maximum of 12MB */
#define	PRELOAD_INCRSIZE	0x4000l		/* a maximum of 16KB */

#define	FSEL_BUFFSIZE		0x4000		/* buffer used in cd_host.s (in bytes) */

/* -------------------------------------------------------------------------- */

typedef	struct	__item
	{
	unsigned int	Settings;
	unsigned long	Length;

	unsigned long	FrameStart;
	unsigned long	FrameLength;

	unsigned char	Comments[ MAX_COMLEN ];
	unsigned char	PathName[ MAX_PATHNAME ];

	unsigned int	Hite;
	unsigned int	OffsetY;
	unsigned int	StartX;

	unsigned int	Cluster;

	struct	__item	*prev;
	struct	__item	*next;
	} ITEM;

#define	IT_CHARPAD	0x00FF

#define	IT_TYPE		0x0F00
#define	IT_SESSION	0x0100
#define	IT_TRACK	0x0200
#define	IT_ITEM		0x0400
#define	IT_LAST		0x0800

#define	IT_SELECTED	0x8000

/* -------------------------------------------------------------------------- */

typedef	struct	__cdrom
	{
	unsigned int	Settings;

	unsigned char	CdRomName[ MAX_ROMNAME ];
	unsigned char	PathName[ MAX_PATHNAME ];

	unsigned int	NoSessions;
	unsigned int	NoTracks;
	unsigned int	NoItems;

	unsigned int	NoSelItems;

	struct	__item	*SelItem;

	struct	__item	*FirstItem;
	struct	__item	*LastItem;
	} CDROM;

#define	GL_DOCUNOTSAVED		0x0001
#define	GL_DOCUNEW		0x0002

/* -------------------------------------------------------------------------- */
/* structure to save commands to/from SERVO PROCESSOR */

#define	MAX_COMMANDS	1024

typedef	struct	__comnd
	{
	unsigned int	Type;
	unsigned int	Command;
	unsigned int	Parameter;

	struct	__comnd	*next;
	} COMND;

#define	COMND_FROMSERVO	0
#define	COMND_TOSERVO	1

/* -------------------------------------------------------------------------- */

#endif

/******************************************************************************/
/* End of ST_STRUC.H							      */
/******************************************************************************/
