/******************************************************************************/
/* ST_TOS.C								      */
/******************************************************************************/

#include "st_def.h"
#include "st_tos.h"

/* -------------------------------------------------------------------------- */

extern	int	gl_appid;

/* -------------------------------------------------------------------------- */

int	gl_tos_country = 0;

unsigned int	gl_tos_version;

int	gl_mint_installed = FALSE;
int	gl_spd_installed = FALSE;

/* -------------------------------------------------------------------------- */

static	long	st_get_tos_country( void );

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	st_get_tos_version()
{
register void	*savessp;

	savessp = Super(0L);
	gl_tos_version = *(unsigned int *)(*(long *)(0x4f2) + 2);
	Super(savessp);
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

int	st_get_cookie(cookie, value)
register unsigned char	*cookie;
register long	*value;
{
register Cookie	*cookie_ptr;
register void	*savessp;

	savessp = Super(NULL);			/* Jump into supervisor mode */
	cookie_ptr = *(Cookie **)(0x5a0);	/* grab ptr to cookie jar */
	Super(savessp);				/* and return to user mode */

	if (cookie_ptr == NULL)
		return( FALSE );

/* Look for the cookie in the cookie jar */
/* Break the loop when a NULL cookie is encountered */

	do
	{
		if (!strncmp((char *)(&(cookie_ptr->c)), cookie, 4))
		{

/* If pointing at desired cookie, return cookie value(if a valid */
/* pointer for value is passed) and designate success */

			if (value != NULL)
				(*value) = cookie_ptr->v;

			return(TRUE);
		}
		cookie_ptr++;

	} while (cookie_ptr->c != 0L);

/* And indicate failure when NULL cookie encountered */

	return(FALSE);
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

int	st_get_language()
{
unsigned char	*cp;
AKP_Cookie cookieval;

	shel_envrn(&cp, "AE_LANG=");
	if (cp)
	{
		gl_tos_country = atoi(cp);
	}
	else
	{
		gl_tos_country = (unsigned int )(st_get_cookie( COOKIE_AKP, (long *)(&cookieval)) ?
							cookieval.language_pref : Supexec(st_get_tos_country));
	}

	if (gl_tos_country >= MAX_TOS_LANGUAGE)
		gl_tos_country = 0;

	return(gl_tos_country);
}

/* -----------------------------------------------------------------------------
 */

static	long	st_get_tos_country()
{
register OSHEADER *theOS;
register int	country;

	theOS = *((OSHEADER **)(0x4f2L));
	if (theOS != NULL)
	{
		country = (theOS->os_conf & 0xfffe);
		country >>= 1;

		return((long)country);
	}
	return(0);
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

int	st_ismint_installed()
{
register int	retval;
long	cookie_value;

/* If running under MiNT then install a string for St-Sutra in the menu */

	if (retval = st_get_cookie("MiNT", &cookie_value))
	{
		menu_register(gl_appid, "  CD ROM Emulator");
	}

	return(gl_mint_installed = retval);
}

/* -----------------------------------------------------------------------------
 */

int	st_isspd_installed()
{
long	cookie_value;

	gl_spd_installed = FALSE;

	if (!st_get_cookie(COOKIE_FSM, &cookie_value))
		return(FALSE);

	if (strncmp((char *)cookie_value, COOKIE_FSM_VAL, 4))
		return(FALSE);

	gl_spd_installed = TRUE;
	return(TRUE);
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	st_error_appl_init()
{
	form_alert(1, "[1][Error in appl_init()][OK]");
	return;
}

/* -----------------------------------------------------------------------------
 */

void	st_error_load_resource()
{

static	unsigned char	*lang_alert[] =
	{
"[1][Can not find the|Resource File or|Bad format in the|Resource.][ OK ]",
"[1][Fichier Resource introuvable| ou d'un format inconnu!][ CONFIRMER ]",
""
	};

static	int	lang_code[] = { 0,0,1,0, 0,0,0,1, 0,0,0,0, 0,0,0,0, 0 };

	form_alert(1, lang_alert[ lang_code[ gl_tos_country ]]);
	return;
}

/******************************************************************************/
/* End od ST_TOS.C							      */
/******************************************************************************/
